#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.XlsIO;

namespace EssentialXlsIOSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "XLS";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new Excel spreadsheet being generated using Essential XlsIO.  At the end of the spreadsheet generation, an option will be provided to view the generated Excel file. Please note that you need to have an Excel viewer installed in order to view the generated Excel file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential XlsIO Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


    	private void button1_Click(object sender, System.EventArgs e)
		{
			//New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();
			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;

			//A new workbook is created.[Equivalent to creating a new workbook in MS Excel]
			//The new workbook will have 3 worksheets
			IWorkbook workbook = excelEngine.Excel.Workbooks.Open("template.xls"); 
			//The first worksheet object in the worksheets collection is accessed.
			IWorksheet sheet = workbook.Worksheets[0];	
		


		
			//Setting height and width.
			int height = 100; // pixel
			int width = 150; // pixel

            // getting all the filenames from the data-directory
            string[] files = System.IO.Directory.GetFiles( "../../Data");

            // array with valid file-extensions
            string[] extensions = { ".jpg", ".gif", ".png" };

            // processing the files
            for( int cnt_f = 0 ; cnt_f < files.Length ; cnt_f++ )
             {
                // filter for valid file-extensions
                for( int cnt_e = 0 ; cnt_e < extensions.Length ; cnt_e++ )
                 {
                    if( files[cnt_f].EndsWith( extensions[cnt_e] ) )
                     {
                        AddPicture( sheet, cnt_f, files[cnt_f], width, height );
                        break;
                     }
                 }
	         }




			//Saving the workbook to disk.
			workbook.SaveAs("Sample.xls");

			//Close the workbook.
			workbook.Close();

			//No exception will be thrown if there are unsaved workbooks.
			excelEngine.ThrowNotSavedOnDestroy = false;
			excelEngine.Dispose(); 
			//Message box confirmation to view the created spreadsheet.
			if (MessageBox.Show ("Do you want to view the workbook?", "Workbook has been created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the Excel file using the default Application.[MS Excel Or Free ExcelViewer]
				System.Diagnostics.Process.Start("Sample.xls");
				//Exit
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
			
		}

        // inserts a picture into column 1 of the sheet and adds original size, scale-factors and resulting size in the columns left of it
        // Parameters:
        //   offset: the number of the image. Since we need two rows for each image we just multiply by 2 to get the rownumber
        //   newWidth, newHeight: image-size as it should be after scaling
        private void AddPicture( IWorksheet sheet, int offset, string path, int newWidth, int newHeight )
         {
            int row = offset * 2 + 1;
         
            //Adding picture in column 1
            IPictureShape pict = sheet.Pictures.AddPicture( row, 1, path );

            // write original size into column 2
            sheet[row, 2].Value = string.Format( "original Width: {0}", pict.Width ); 
            sheet[row + 1, 2].Value = string.Format( "original Height: {0}", pict.Height ); 
            sheet[row + 1, 2].VerticalAlignment = ExcelVAlign.VAlignTop;
			
            // calculating the scale-factors to resize to the desired size (don't care about aspect-ratio)
            int verticalScale = (int)( newHeight * 100.0 / pict.Height + 0.5 );
            int horizontalScale = (int)( newWidth * 100.0 / pict.Width + 0.5 );

            // write scale-factors into column 3
            sheet[row, 3].Value = string.Format( "h-factor: {0}%", horizontalScale ); 
            sheet[row + 1, 3].Value = string.Format( "v-factor: {0}%", verticalScale ); 
            sheet[row + 1, 3].VerticalAlignment = ExcelVAlign.VAlignTop;

            // resizing...
            pict.Scale( horizontalScale, verticalScale );
            
            // write the resulting size into column 4
            sheet[row, 4].Value = string.Format( "new Width: {0}", pict.Width ); // should be newWidth
            sheet[row + 1, 4].Value = string.Format( "new Height: {0}", pict.Height ); // sould be newHeight
            sheet[row + 1, 4].VerticalAlignment = ExcelVAlign.VAlignTop;

            // just to get enough space for the next picture
            sheet[row + 1, 1].RowHeight = newHeight; 
        }
	}
}



